ASN1TaggedObject (Bouncy Castle Library 1.54 API Specification)
Date: 2015-12-29

org.bouncycastle.asn1

## Class ASN1TaggedObject

- java.lang.Object
- - org.bouncycastle.asn1.ASN1Object
  - - org.bouncycastle.asn1.ASN1Primitive
    - - org.bouncycastle.asn1.ASN1TaggedObject

- All Implemented Interfaces:
    ASN1Encodable, ASN1TaggedObjectParser, InMemoryRepresentable, Encodable
  Direct Known Subclasses:
    BERTaggedObject, DERTaggedObject, DLTaggedObject

      public abstract class ASN1TaggedObject
      extends ASN1Primitive
      implements ASN1TaggedObjectParser

  ASN.1 TaggedObject - in ASN.1 notation this is any object preceded by a [n] where n is some number - these are assumed to follow the construction rules (as with sequences).

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ASN1TaggedObject(boolean explicit, int tagNo, ASN1Encodable obj)` Create a tagged object with the style given by the value of explicit.

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `static ASN1TaggedObject` | `getInstance(ASN1TaggedObject obj, boolean explicit)`
    `static ASN1TaggedObject` | `getInstance(java.lang.Object obj)`
    `ASN1Primitive` | `getLoadedObject()` Get the in-memory representation of the ASN.1 object.
    `ASN1Primitive` | `getObject()` return whatever was following the tag.
    `ASN1Encodable` | `getObjectParser(int tag, boolean isExplicit)` Return the object held in this tagged object as a parser assuming it has the type of the passed in tag.
    `int` | `getTagNo()`
    `int` | `hashCode()`
    `boolean` | `isEmpty()`
    `boolean` | `isExplicit()` return whether or not the object may be explicitly tagged.
    `java.lang.String` | `toString()`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Primitive

      `equals, fromByteArray, toASN1Primitive`

    - ### Methods inherited from class org.bouncycastle.asn1.ASN1Object

      `getEncoded, getEncoded, hasEncodedTagValue, toASN1Object`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

    - ### Methods inherited from interface org.bouncycastle.asn1.ASN1Encodable

      `toASN1Primitive`

- - ### Constructor Detail

    - #### ASN1TaggedObject

          public ASN1TaggedObject(boolean explicit,
                          int tagNo,
                          ASN1Encodable obj)

      Create a tagged object with the style given by the value of explicit.

      If the object implements ASN1Choice the tag style will always be changed to explicit in accordance with the ASN.1 encoding rules.

      Parameters:
        `explicit` - true if the object is explicitly tagged.
        `tagNo` - the tag number for this object.
        `obj` - the tagged object.

  - ### Method Detail

    - #### getInstance

          public static ASN1TaggedObject getInstance(ASN1TaggedObject obj,
                                     boolean explicit)

    - #### getInstance

          public static ASN1TaggedObject getInstance(java.lang.Object obj)

    - #### hashCode

          public int hashCode()

      Specified by:
        `hashCode` in class `ASN1Primitive`

    - #### getTagNo

          public int getTagNo()

      Specified by:
        `getTagNo` in interface `ASN1TaggedObjectParser`

    - #### isExplicit

          public boolean isExplicit()

      return whether or not the object may be explicitly tagged.

      Note: if the object has been read from an input stream, the only time you can be sure if isExplicit is returning the true state of affairs is if it returns false. An implicitly tagged object may appear to be explicitly tagged, so you need to understand the context under which the reading was done as well, see getObject below.

    - #### isEmpty

          public boolean isEmpty()

    - #### getObject

          public ASN1Primitive getObject()

      return whatever was following the tag.

      Note: tagged objects are generally context dependent if you're trying to extract a tagged object you should be going via the appropriate getInstance method.

    - #### getObjectParser

          public ASN1Encodable getObjectParser(int tag,
                                      boolean isExplicit)
                                        throws java.io.IOException

      Return the object held in this tagged object as a parser assuming it has the type of the passed in tag. If the object doesn't have a parser associated with it, the base object is returned.
      Specified by:
        `getObjectParser` in interface `ASN1TaggedObjectParser`
      Throws:
        `java.io.IOException`

    - #### getLoadedObject

          public ASN1Primitive getLoadedObject()

      Description copied from interface: `InMemoryRepresentable`
      Get the in-memory representation of the ASN.1 object.
      Specified by:
        `getLoadedObject` in interface `InMemoryRepresentable`
      Returns:
        an ASN1Primitive representing the loaded object.

    - #### toString

          public java.lang.String toString()

      Overrides:
        `toString` in class `java.lang.Object`